<?php
if(!defined('DEDEINC')) exit('Request Error!');

require_once(DEDEINC.'/channelunit.class.php');

//---------------------------------------
// Html 標記WAP語言
//----------------------------------------
function html2wml($content)
{
     //保留圖片
     preg_match_all("/<img([^>]*)>/isU", $content, $imgarr);
     if(isset($imgarr[0]) && count($imgarr[0])>0 )
     {
     	foreach($imgarr[0] as $k=>$v) $content = str_replace($v, "WAP-IMG::{$k}", $content);
     }
     // 過濾掉樣式表和腳本
     $content = preg_replace("/<style .*?<\/style>/is", "", $content);
     $content = preg_replace("/<script .*?<\/script>/is", "", $content);
     // 首先將各種可以引起換行的標籤（如<br />、<p> 之類）替換成換行符"\n"
     $content = preg_replace("/<br \s*\/?\/>/i", "\n", $content);
     $content = preg_replace("/<\/?p>/i", "\n", $content);
     $content = preg_replace("/<\/?td>/i", "\n", $content);
     $content = preg_replace("/<\/?div>/i", "\n", $content);
     $content = preg_replace("/<\/?blockquote>/i", "\n", $content);
     $content = preg_replace("/<\/?li>/i", "\n", $content);
     // 將"&nbsp;"替換為空格
     $content = preg_replace("/\&nbsp\;/i", " ", $content);
     $content = preg_replace("/\&nbsp/i", " ", $content);
     // 過濾掉剩下的 HTML 標籤
     $content = strip_tags($content);
     // 將 HTML 中的實體（entity）轉化為它所對應的字符
     $content = html_entity_decode($content, ENT_QUOTES, "GB2312");
     // 過濾掉不能轉化的實體（entity）
     $content = preg_replace('/\&\#.*?\;/i', '', $content);
     // 上面是將 HTML 網頁內容轉化為帶換行的純文本，下面是將這些純文本轉化為 WML。
     $content = str_replace('$', '$$', $content);
     $content = str_replace("\r\n", "\n", htmlspecialchars($content));
     $content = explode("\n", $content);
     for ($i = 0; $i < count($content); $i++)
     {
        $content[$i] = trim($content[$i]);
        // 如果去掉全角空格為空行，則設為空行，否則不對全角空格過濾。
        if (str_replace('　', '', $content[$i]) == '') $content[$i] = '';
     }
     $content = str_replace("<p><br /></p>\n", "", '<p>'.implode("<br /></p>\n<p>", $content)."<br /></p>\n");
     
     //還原圖片
     if(isset($imgarr[0]) && count($imgarr[0])>0 )
     {
				foreach($imgarr[0] as $k=>$v)
				{
					$attstr = (preg_match('#/$#', $imgarr[1][$k])) ? '<img '.$imgarr[1][$k].'>' : '<img '.$imgarr[1][$k].' />';
					$content = str_replace("WAP-IMG::{$k}", $attstr, $content);
				}
     }
     
     $content = preg_replace("/&amp;[a-z]{3,10};/isU", ' ', $content);
     
     return $content;
}

function text2wml($content)
{
     $content = str_replace('$', '$$', $content);
     $content = str_replace("\r\n", "\n", htmlspecialchars($content));
     $content = explode("\n", $content);
     for ($i = 0; $i < count($content); $i++)
     {
        // 過濾首尾空格
        $content[$i] = trim($content[$i]);
        // 如果去掉全角空格為空行，則設為空行，否則不對全角空格過濾。
        if (str_replace("　", "", $content[$i]) == "") $content[$i] = "";
     }
     //合併各行，轉化為 WML，並過濾掉空行
     $content = str_replace("<p><br /></p>\n", "", "<p>".implode("<br /></p>\n<p>", $content)."<br /></p>\n");
     return $content;
}

//----------------------
//把GBK字符轉換成UTF8
//----------------------
function ConvertCharset($varlist)
{
	global $cfg_soft_lang;
	if(preg_match('#utf#i',$cfg_soft_lang)) return 0;
	$varlists = explode(',',$varlist);
	$numargs=count($varlists);
	for($i = 0; $i < $numargs; $i++)
	{   
		if(isset($GLOBALS[$varlists[$i]]))
		{
			$GLOBALS[$varlists[$i]] = gb2utf8($GLOBALS[$varlists[$i]]);
		}
	} 
	return 1;
}

//----------------------
//處理特殊字符
//----------------------
function ConvertStr($str)
{
	$str = str_replace("&amp;","##amp;",$str);
	$str = str_replace("&","&amp;",$str);
	$str = preg_replace("#[\"><']#","",$str);
	$str = str_replace("##amp;","&amp;",$str);
  return $str;
}

?>
